(*  Title:      /heterogeneous_datatypes/Tools/bnf_nu_fp_tactics.ML
    Author:     Dmitriy Traytel, TU Muenchen
    Author:     Fabian Meier, ETH Zürich
    Copyright   2016

Tactics for the non-uniform datatype construction.
*)

signature BNF_NU_FP_TACTICS =
sig
  val mk_invar_shape_depth_iff_leaf_tac: Proof.context -> thm -> cterm -> cterm ->
    thm list -> thm list -> thm list -> tactic
  val mk_invar_shape_depth_iff_node_tac: Proof.context -> thm -> cterm -> cterm -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> tactic
  val mk_invar_shape_mk_shape_tac: Proof.context -> cterm -> cterm -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> tactic
  val mk_invar_wit_raw_tac: Proof.context -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> tactic

  val mk_typedef_tac: Proof.context -> cterm -> thm -> tactic

  val mk_invar_map_shape_closed_tac: Proof.context -> thm -> cterm list ->
    cterm list -> thm list -> thm list -> thm list -> thm list -> thm list -> tactic

  val mk_invar_map_raw_closed_tac: Proof.context -> thm -> cterm list ->
    cterm list -> thm list -> thm list -> thm list -> thm list -> thm list -> tactic

  val mk_lift_tac: Proof.context -> thm -> tactic
  val mk_invar_wit_tac: Proof.context -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    tactic
  val mk_wit_set_tac: Proof.context -> thm list -> thm list -> thm list ->
    thm list -> tactic

  val mk_flat_shape_unflat_shape_tac: Proof.context -> thm -> cterm list ->
    cterm list -> thm -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> tactic
  val mk_unflat_shape_flat_shape_tac: Proof.context -> thm -> cterm list ->
    cterm list -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list  -> thm list -> thm list -> thm list -> thm list -> tactic

  val mk_invar_shape_flat_shape_tac: Proof.context -> thm -> cterm list ->
    cterm list -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> tactic
  val mk_invar_raw_flat_raw_tac: Proof.context -> thm -> cterm list -> cterm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> tactic
  val mk_invar_shape_unflat_shape_tac: Proof.context -> thm -> cterm list -> cterm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> tactic
  val mk_invar_raw_unflat_raw_tac: Proof.context -> thm -> cterm list -> cterm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> tactic
  val mk_flat_raw_unflat_raw_tac: Proof.context -> thm -> cterm list -> cterm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> tactic
  val mk_unflat_raw_flat_raw_tac: Proof.context -> thm -> cterm list -> cterm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> tactic

  val mk_cimmerse_shape_inj_tac: Proof.context -> cterm -> cterm -> cterm list -> thm -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm -> tactic
  val mk_invar_cimmerse_raw_tac: Proof.context -> cterm -> cterm -> thm -> thm list -> thm list ->
    thm list -> thm list -> tactic
  val mk_unCons_cimmerse_raw_tac: Proof.context -> cterm -> cterm -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> thm -> thm -> thm ->
    tactic

  (* Constructor bijection *)

  val mk_un_T_o_T_tac: Proof.context -> thm -> thm -> thm ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> tactic

  val mk_T_o_un_T_tac: Proof.context -> thm -> thm -> thm -> thm -> thm -> cterm ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> tactic

  (* map *)

  val mk_map_flat_shape_tac: Proof.context -> thm -> cterm list -> cterm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> tactic
  val mk_map_flat_raw_tac: Proof.context -> thm -> cterm list -> cterm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> tactic
  val mk_map_T_eq_tac: Proof.context -> thm list -> thm -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> tactic

  (* set *)

  val mk_set_flat_shape_tac: Proof.context -> thm -> cterm list -> cterm list ->
    thm list -> thm list -> thm list -> tactic
  val mk_set_flat_raw_tac: Proof.context -> thm -> cterm list -> cterm list ->
    thm list -> thm list -> thm list -> thm list -> tactic
  val mk_set_T_eq_tac: Proof.context -> thm list -> thm -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> tactic

  (* rel *)

  val mk_rel_final_tac: Proof.context -> thm -> thm -> tactic
  val mk_rel_flat_shape_raw_tac: Proof.context -> thm -> cterm list -> cterm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> tactic
  val mk_rel_flat_raw_raw_tac: Proof.context -> thm -> cterm list -> cterm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> tactic
  val mk_rel_T_eq_tac: Proof.context -> thm list -> thm -> thm list -> thm list ->
    thm list -> thm list list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> tactic

  (* co-datatypes *)

  val mk_invar_map_raw_closed_cotac: Proof.context -> cterm list -> cterm list ->
    thm -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> tactic
  val mk_invar_raw_flat_raw_cotac: Proof.context -> cterm list -> thm -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> tactic
  val mk_invar_raw_unflat_raw_cotac: Proof.context -> cterm list -> thm -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> tactic
  val mk_flat_raw_unflat_raw_cotac: Proof.context -> cterm list -> cterm list ->
    cterm list -> thm -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> tactic
  val mk_unflat_raw_flat_raw_cotac: Proof.context -> cterm list -> cterm list ->
    cterm list -> thm -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> tactic
  val mk_map_flat_raw_cotac: Proof.context -> cterm list -> cterm list -> cterm list ->
    thm -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> tactic
  val mk_set_flat_raw_cotac: Proof.context -> cterm -> cterm list list -> cterm list -> thm ->
    thm list -> int -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> tactic
  val mk_rel_flat_raw_raw_cotac: Proof.context -> cterm list -> cterm list -> cterm list ->
    cterm list -> thm -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> tactic

  (* bnf_fp_ind *)

  val mk_P_mono_tac: Proof.context -> int -> thm -> cterm list -> thm ->  tactic
  val mk_PP_unCons_co_tac: BNF_Util.fp_kind -> Proof.context -> thm -> thm -> thm list -> thm ->
    cterm list list -> thm list -> thm -> thm list -> thm list -> thm -> thm list -> thm list ->
    thm list -> thm list -> thm list -> thm -> thm list -> thm list -> thm list -> tactic
  val mk_PP_co_tac: BNF_Util.fp_kind -> Proof.context -> thm -> cterm list -> cterm list ->
    thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list -> thm list ->
    thm list -> thm list -> tactic
  val mk_P_tac: Proof.context -> thm -> cterm -> cterm -> cterm list -> cterm -> cterm ->
    thm -> thm -> thm -> thm -> thm list -> thm list -> tactic
  val mk_P_cotac: Proof.context -> cterm list -> thm -> thm -> thm -> thm -> thm list -> thm ->
    thm -> thm -> thm list -> thm list -> tactic

  (* bnf_fp_rec *)

  val mk_defobj_natural_tac: Proof.context -> tactic
  val mk_argobj_natural_tac: Proof.context -> tactic
  val mk_defobj_invar_tac: Proof.context -> tactic
  val mk_argobj_invar_tac: Proof.context -> tactic

  (* lemmas about f *)

  val mk_f_shape_flat_shape_tac: Proof.context -> tactic
  val mk_invar_shape_f_shape_tac: Proof.context -> tactic
  val mk_f_raw_flat_raw_tac: Proof.context -> tactic
  val mk_invar_raw_f_raw_tac: Proof.context -> tactic
  val mk_f_T_Appl_tac: Proof.context -> tactic
end;

structure BNF_NU_FP_Tactics : BNF_NU_FP_TACTICS =
struct

open Ctr_Sugar_Util
open BNF_FP_Rec_Sugar_Util
open BNF_Tactics
open BNF_Util

fun mk_invar_shape_mk_shape_tac ctxt P u invar_simps mk_shape_simps pred_maps pred_Trues pred_congs label_splits =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME [P, u]) @{thm list.induct})) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val intro = resolve_tac ctxt [allI, impI, conjI];
      val simp = full_simp_tac (fold Simplifier.add_cong pred_congs
        (fold Splitter.add_split label_splits
        (ss_only (flat [invar_simps, mk_shape_simps, pred_maps, pred_Trues, IHs,
        @{thms simp_thms list.case fstI sndI if_True o_apply}]) ctxt)));
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, intro, simp])
    end) ctxt);

fun mk_invar_shape_depth_iff_leaf_tac ctxt exhaust P u invar_simps inject distinct =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME [u, P]) exhaust)) THEN
  ALLGOALS
    (let
      val simp = full_simp_tac
        (ss_only (flat [invar_simps, inject, distinct, @{thms simp_thms list.case}]) ctxt);
    in
      REPEAT_DETERM o FIRST' [hyp_subst_tac ctxt, simp]
    end);

fun mk_invar_shape_depth_iff_node_tac ctxt exhaust P u invar_simps inject distinct
    pred_maps label_case label_distinct =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME [u, P]) exhaust)) THEN
  ALLGOALS
    (let
      val simp = full_simp_tac
        (ss_only (flat [invar_simps, inject, distinct, pred_maps, label_case,
        label_distinct, @{thms simp_thms list.case if_True if_False}]) ctxt);
    in
      REPEAT_DETERM o FIRST' [hyp_subst_tac ctxt, simp]
    end);

fun mk_invar_wit_raw_tac ctxt wit_defs invar_raw_simps invar_shape_simps
    label_cases F_pred_maps F_pred_sets F_set_maps F_wits
    G_pred_maps G_pred_sets G_set_maps G_wits =
  ALLGOALS (REPEAT_DETERM o
    FIRST' [hyp_subst_tac ctxt,
    resolve_tac ctxt [allI, impI, conjI],
    etac ctxt imageE,
    dresolve_tac ctxt F_wits,
    dresolve_tac ctxt G_wits,
    full_simp_tac (ss_only (flat [wit_defs, invar_raw_simps, invar_shape_simps,
      label_cases,
      F_pred_maps, F_pred_sets, F_set_maps, G_pred_maps, G_pred_sets, G_set_maps,
      @{thms list.case Ball_def sndI fstI if_True o_apply refl}]) ctxt)]);

fun mk_typedef_tac ctxt wit_appl invar_wit =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt [NONE, SOME wit_appl] exI) THEN'
    rtac ctxt CollectI THEN' rtac ctxt invar_wit);

fun mk_invar_map_shape_closed_tac ctxt induct Ps us
    shape_map_thms invar_simps pred_maps pred_congs label_splits =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val apply_IHs =
        resolve_tac ctxt (map (fn thm => thm RS spec) IHs) THEN_ALL_NEW assume_tac ctxt;
      val intro = resolve_tac ctxt (allI :: impI :: conjI :: map (fn thm => refl RS thm) pred_congs);
      val elim = eresolve_tac ctxt [conjE, impE, exE];
      val simp = full_simp_tac
        (fold Splitter.add_split (label_splits @ @{thms list.splits if_splits})
        (ss_only (flat [shape_map_thms, invar_simps, pred_maps,
            @{thms o_apply simp_thms list.inject list.distinct}])
          ctxt));
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, intro, elim, apply_IHs, simp])
    end) ctxt);

fun mk_invar_map_raw_closed_tac ctxt induct Ps us
    map_thms invar_simps pred_maps invar_map_shape_closed_thms pred_congs =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val apply_IHs =
        resolve_tac ctxt (map (fn thm => thm RS spec) IHs) THEN_ALL_NEW assume_tac ctxt;
      val intro = resolve_tac ctxt (allI :: impI :: conjI :: map (fn thm => refl RS thm) pred_congs);
      val simp = full_simp_tac
        (ss_only (flat [map_thms, invar_simps, pred_maps, invar_map_shape_closed_thms, @{thms o_apply}])
          ctxt);
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, intro, apply_IHs, simp])
    end) ctxt);

fun mk_lift_tac ctxt thm =
  BNF_Tactics.unfold_thms_tac ctxt [thm, @{thm mem_Collect_eq}] THEN
  HEADGOAL (assume_tac ctxt);

fun mk_invar_wit_tac ctxt invar_raw_simps invar_shape_simps
    label_cases F_pred_maps F_pred_sets F_set_maps F_wits
    G_pred_maps G_pred_sets G_set_maps G_wits =
  Ctr_Sugar_Tactics.unfold_thms_tac ctxt @{thms mem_Collect_eq} THEN
  mk_invar_wit_raw_tac ctxt [] invar_raw_simps invar_shape_simps
    label_cases F_pred_maps F_pred_sets F_set_maps F_wits
    G_pred_maps G_pred_sets G_set_maps G_wits;

fun mk_wit_set_tac ctxt F_wits G_wits raw_sets shape_sets =
  ALLGOALS (REPEAT_DETERM o
    FIRST' [hyp_subst_tac ctxt,
    eresolve_tac ctxt (UnE :: imageE :: @{thms UN_E emptyE insertE}),
    dresolve_tac ctxt F_wits,
    dresolve_tac ctxt G_wits,
    full_simp_tac (ss_only (flat [raw_sets, shape_sets,
      @{thms o_apply refl}]) ctxt)]);

fun mk_flat_shape_unflat_shape_tac ctxt induct Ps us
    label_exhaust label_splits label_distincts shape_cases shape_injects invar_shape_depth_iffs
    unflat_simps flat_simps invar_simps
    pred_maps map_comps map_cong_preds map_idents pred_mono_strongs =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val case_distinction_label = SOLVED'
        (rtac ctxt label_exhaust THEN_ALL_NEW
          (TRY o (etac ctxt notE THEN_ALL_NEW assume_tac ctxt)));
      val apply_IHs =
        resolve_tac ctxt (map (fn thm => thm RS spec RS mp) IHs) THEN_ALL_NEW assume_tac ctxt;
      val intro = resolve_tac ctxt (allI :: impI :: conjI ::
        map2 (fn cong => fn id => trans OF [cong, id]) map_cong_preds map_idents);
      val elim = eresolve_tac ctxt (conjE :: disjE :: exE :: pred_mono_strongs);
      val simp = full_simp_tac
        (fold Splitter.add_split (label_splits @ @{thms list.splits if_splits})
        (ss_only (flat [shape_cases, shape_injects, invar_shape_depth_iffs,
            unflat_simps, flat_simps, invar_simps, pred_maps, map_comps, label_distincts,
            @{thms snoc.simps snoc_neq_Nil id_apply o_apply simp_thms
              list.inject de_Morgan_conj de_Morgan_disj triv_forall_equality}])
          ctxt));
    in
      HEADGOAL (REPEAT_DETERM o
        FIRST' [hyp_subst_tac ctxt, intro, elim, case_distinction_label, apply_IHs, simp])
    end) ctxt);

fun mk_unflat_shape_flat_shape_tac ctxt induct Ps us
    shape_injects unflat_simps flat_simps invar_simps
    F_pred_maps F_map_comps F_pred_Trues shape_case F_map_cong_preds F_map_idents
    F_pred_mono_strongs label_splits =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val apply_IHs =
        resolve_tac ctxt (map (fn thm => thm RS spec RS mp) IHs) THEN_ALL_NEW assume_tac ctxt;
      val intro = resolve_tac ctxt (allI :: impI :: conjI ::
        map2 (fn cong => fn id => trans OF [cong, id]) F_map_cong_preds F_map_idents);
      val elim = eresolve_tac ctxt (conjE :: disjE :: exE :: F_pred_mono_strongs);
      val simp = full_simp_tac
        (fold Splitter.add_split (label_splits @ @{thms list.splits if_splits sum.splits})
        (ss_only (flat [shape_case, shape_injects,
            unflat_simps, flat_simps, invar_simps, F_pred_maps, F_map_comps, F_pred_Trues,
            @{thms id_apply o_apply refl simp_thms list.simps
              de_Morgan_conj de_Morgan_disj triv_forall_equality}])
          ctxt));
    in
      HEADGOAL (REPEAT_DETERM o
        FIRST' [hyp_subst_tac ctxt, intro, elim, apply_IHs, simp])
    end) ctxt);

fun mk_invar_shape_flat_shape_tac ctxt induct Ps us flat_simps invar_simps F_pred_maps
    F_pred_Trues F_pred_mono_strongs label_splits F_pred_congs =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val apply_IHs =
        resolve_tac ctxt (map (fn thm => thm RS spec RS mp) IHs) THEN_ALL_NEW assume_tac ctxt;
      val intro = resolve_tac ctxt [allI, impI, conjI];
      val elim = eresolve_tac ctxt (conjE :: disjE :: exE :: not_sym :: (not_sym RS disjI1) ::
        F_pred_mono_strongs);
      val simp = full_simp_tac (fold Simplifier.add_cong F_pred_congs
        (fold Splitter.add_split (label_splits @ @{thms list.splits sum.splits if_splits})
        (ss_only (flat [flat_simps, invar_simps, F_pred_maps, F_pred_Trues,
            @{thms snoc.simps snoc_neq_Nil id_apply o_apply simp_thms
              list.inject list.distinct de_Morgan_conj de_Morgan_disj triv_forall_equality}])
          ctxt)));
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, intro, elim, apply_IHs, simp])
    end) ctxt);

fun mk_invar_raw_flat_raw_tac ctxt induct Ps us flat_simps invar_simps invar_shape_flat_shapes
    G_pred_maps G_pred_mono_strongs =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val apply_IHs =
        resolve_tac ctxt (map (fn thm => thm RS spec RS mp) IHs) THEN_ALL_NEW assume_tac ctxt;
      val intro = resolve_tac ctxt [allI, impI, conjI];
      val elim = eresolve_tac ctxt (conjE :: disjE :: exE :: not_sym :: (not_sym RS disjI1) ::
        (G_pred_mono_strongs @ invar_shape_flat_shapes));
      val simp = full_simp_tac (fold Splitter.add_split (@{thms list.splits sum.splits if_splits})
        (ss_only (flat [flat_simps, invar_simps, G_pred_maps,
            @{thms snoc.simps[symmetric] snoc_neq_Nil id_apply o_apply simp_thms
              list.inject list.distinct de_Morgan_conj de_Morgan_disj triv_forall_equality}])
          ctxt));
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, intro, elim, apply_IHs, simp])
    end) ctxt);

fun mk_invar_shape_unflat_shape_tac ctxt induct Ps us unflat_simps invar_simps
    F_pred_maps F_pred_mono_strongs label_splits label_distincts =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val apply_IHs =
        resolve_tac ctxt (map (fn thm => thm RS spec RS mp) IHs) THEN_ALL_NEW assume_tac ctxt;
      val intro = resolve_tac ctxt [allI, impI, conjI];
      val elim = eresolve_tac ctxt (conjE :: disjE :: exE :: not_sym :: F_pred_mono_strongs);
      val simp = full_simp_tac (fold Splitter.add_split (label_splits @ @{thms list.splits sum.splits if_splits})
        (ss_only (flat [unflat_simps, invar_simps, F_pred_maps, label_distincts,
            @{thms snoc.simps snoc_neq_Nil id_apply o_apply simp_thms list.simps
              de_Morgan_conj de_Morgan_disj triv_forall_equality}])
          ctxt));
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, elim, intro, apply_IHs, simp])
    end) ctxt);

fun mk_invar_raw_unflat_raw_tac ctxt induct Ps us unflat_simps invar_simps invar_shape_unflat_shapes
    G_pred_maps G_pred_mono_strongs =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val apply_IHs =
        resolve_tac ctxt (map (fn thm => thm RS spec RS mp) IHs) THEN_ALL_NEW assume_tac ctxt;
      val intro = resolve_tac ctxt [allI, impI, conjI];
      val elim = eresolve_tac ctxt (conjE :: disjE :: exE :: not_sym :: (not_sym RS disjI1) ::
        (G_pred_mono_strongs @ invar_shape_unflat_shapes));
      val simp = full_simp_tac (fold Splitter.add_split (@{thms list.splits sum.splits if_splits})
        (ss_only (flat [unflat_simps, invar_simps, G_pred_maps,
            @{thms snoc.simps[symmetric] snoc_neq_Nil id_apply o_apply simp_thms
              list.inject list.distinct de_Morgan_conj de_Morgan_disj triv_forall_equality}])
          ctxt));
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, intro, elim, apply_IHs, simp])
    end) ctxt);

fun mk_flat_raw_unflat_raw_tac ctxt induct Ps us flat_simps unflat_simps invar_simps raw_injects flat_shape_unflat_shape
    G_pred_maps G_map_comps G_map_cong_preds G_map_idents G_pred_mono_strongs =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val apply_IHs =
        resolve_tac ctxt (map (fn thm => thm RS spec RS mp) IHs) THEN_ALL_NEW assume_tac ctxt;
      val intro = resolve_tac ctxt (allI :: impI :: conjI ::
        map2 (fn cong => fn id => trans OF [cong, id]) G_map_cong_preds G_map_idents);
      val elim = eresolve_tac ctxt (conjE :: disjE :: exE :: not_sym :: (not_sym RS disjI1) ::
        (G_pred_mono_strongs @ flat_shape_unflat_shape));
      val simp = full_simp_tac (fold Splitter.add_split (@{thms list.splits sum.splits if_splits})
        (ss_only (flat [flat_simps, unflat_simps, invar_simps, G_pred_maps, G_map_comps, raw_injects,
            @{thms snoc.simps[symmetric] snoc_neq_Nil id_apply o_apply simp_thms
              list.inject list.distinct de_Morgan_conj de_Morgan_disj triv_forall_equality}])
          ctxt));
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, intro, elim, apply_IHs, simp])
    end) ctxt);

fun mk_unflat_raw_flat_raw_tac ctxt induct Ps us flat_simps unflat_simps invar_simps raw_injects unflat_shape_flat_shape
    G_pred_maps G_map_comps G_map_cong_preds G_map_idents G_pred_mono_strongs =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val apply_IHs =
        resolve_tac ctxt (map (fn thm => thm RS spec RS mp) IHs) THEN_ALL_NEW assume_tac ctxt;
      val intro = resolve_tac ctxt (allI :: impI :: conjI ::
        map2 (fn cong => fn id => trans OF [cong, id]) G_map_cong_preds G_map_idents);
      val elim = eresolve_tac ctxt (conjE :: disjE :: exE :: not_sym :: (not_sym RS disjI1) ::
        (G_pred_mono_strongs @ unflat_shape_flat_shape));
      val simp = full_simp_tac (fold Splitter.add_split (@{thms list.splits sum.splits if_splits})
        (ss_only (flat [flat_simps, unflat_simps, invar_simps, G_pred_maps, G_map_comps, raw_injects,
            @{thms snoc.simps[symmetric] snoc_neq_Nil id_apply o_apply simp_thms
              list.inject list.distinct de_Morgan_conj de_Morgan_disj triv_forall_equality}])
          ctxt));
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, intro, elim, apply_IHs, simp])
    end) ctxt);

fun mk_cimmerse_shape_inj_tac ctxt P u flat_shapes label_exhaust label_case shape_injects
   invar_shape_map_closed invar_shape_unflat_shape flat_shape_unflat_shape
   cimmerse_simps shape_inj_map_strong =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME [P, u]) @{thm list.induct}) THEN'
    REPEAT_DETERM o resolve_tac ctxt [impI, allI] THEN'
    full_simp_tac (ss_only (cimmerse_simps @ @{thms rev.simps(1) id_apply}) ctxt) THEN'
    Subgoal.FOCUS (fn {context = ctxt, prems = IHs, params = params, ...} =>
      let
        val exhaust = infer_instantiate' ctxt [SOME (snd (hd params))] label_exhaust;
        val intro = resolve_tac ctxt [allI, impI];
        val IH = Drule.rotate_prems ~1 (hd IHs RS spec RS spec RS mp RS mp RS mp);
        val arg_congs =
          map (fn f => infer_instantiate' ctxt [NONE, NONE, SOME f] arg_cong) flat_shapes;
        val dest =
          dresolve_tac ctxt (IH :: Drule.rotate_prems ~1 shape_inj_map_strong :: arg_congs);
        val simp = asm_full_simp_tac (ss_only (flat [cimmerse_simps, shape_injects, label_case,
          invar_shape_map_closed, invar_shape_unflat_shape, flat_shape_unflat_shape,
          @{thms o_apply rev_Cons}]) ctxt);
      in
        HEADGOAL (rtac ctxt exhaust THEN_ALL_NEW REPEAT_DETERM o FIRST' [intro, dest, simp])
      end) ctxt);

fun mk_invar_cimmerse_raw_tac ctxt P u label_exhaust label_case invar_map_closed
    invar_unflat cimmerse_simps =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME [P, u]) @{thm list.induct}) THEN'
    REPEAT_DETERM o resolve_tac ctxt [impI, allI] THEN'
    full_simp_tac (ss_only (cimmerse_simps @ @{thms rev.simps(1) id_apply}) ctxt) THEN'
    Subgoal.FOCUS_PARAMS (fn {context = ctxt, params = params, ...} =>
      let
        val exhaust = infer_instantiate' ctxt [SOME (snd (hd params))] label_exhaust;
      in
        HEADGOAL (rtac ctxt exhaust THEN_ALL_NEW
          (REPEAT_DETERM o resolve_tac ctxt [impI, allI] THEN'
           asm_full_simp_tac (ss_only (flat [cimmerse_simps, @{thms rev_Cons o_apply},
             invar_map_closed, invar_unflat, label_case]) ctxt)))
      end) ctxt);

fun mk_unCons_cimmerse_raw_tac ctxt P u label_distinct label_case label_splits unflat_simps
    cimmerse_simps cimmerse_shape_simps raw_injects raw_splits raw_map G_map_comp G_map_cong =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME [P, u]) @{thm list.induct}) THEN'
    rtac ctxt allI THEN'
    full_simp_tac (Simplifier.add_cong G_map_cong
      (ss_only (flat [cimmerse_simps, cimmerse_shape_simps, label_case,
        @{thms snoc.simps(1) rev.simps(1) id_apply}]) ctxt)) THEN'
    rtac ctxt allI THEN'
    SELECT_GOAL (unfold_thms_tac ctxt cimmerse_simps) THEN'
    dtac ctxt spec THEN' etac ctxt trans THEN'
    asm_full_simp_tac (fold Splitter.add_split (label_splits @ raw_splits) (ss_only [] ctxt)) THEN'
    let
      val intro = resolve_tac ctxt [allI, conjI, impI];
      val simp = CHANGED o asm_full_simp_tac (Simplifier.add_cong G_map_cong
          (ss_only (raw_map :: G_map_comp :: flat [cimmerse_simps, cimmerse_shape_simps,
            raw_injects, label_distinct, label_case, unflat_simps,
            @{thms rev_snoc snoc.simps o_apply id_apply}]) ctxt));
    in
      REPEAT_DETERM o FIRST' [intro, hyp_subst_tac ctxt, simp]
    end);


  (* Constructor bijection *)

fun mk_un_T_o_T_tac ctxt T_ctr_def T_dtr_def T_Abs_inverse T_Reps T_Rep_inverses
    invar_raw_simps raw_cases invar_shape_simps shape_cases
    invar_map_raw_closeds invar_flat_raws unflat_flat_raws
    G_pred_maps G_pred_Trues G_map_comps G_map_idents G_pred_congs G_map_congs =
  HEADGOAL (rtac ctxt @{thm pointfree_idI}) THEN
  unfold_tac ctxt [T_ctr_def, T_dtr_def] THEN
  HEADGOAL (full_simp_tac (fold Simplifier.add_cong (G_pred_congs @ G_map_congs)
        (ss_only (flat [[T_Abs_inverse],
            map (unfold_thms ctxt @{thms mem_Collect_eq}) T_Reps, T_Rep_inverses,
            invar_raw_simps, raw_cases, invar_shape_simps, shape_cases,
            invar_map_raw_closeds, invar_flat_raws, unflat_flat_raws,
            G_pred_maps, G_pred_Trues, G_map_comps, G_map_idents,
            @{thms snoc.simps(1)[symmetric] o_apply mem_Collect_eq list.case}])
          ctxt)));

fun mk_T_o_un_T_tac ctxt T_ctr_def T_dtr_def T_Rep T_Rep_inject raw_exhaust cT_Rep
    T_Abs_inverses T_Reps T_Rep_inverses invar_raw_simps raw_cases raw_injects
    invar_shape_simps shape_cases invar_map_raw_closeds invar_flat_raws
    invar_unflat_raws flat_unflat_raws pred_maps pred_Trues map_comps
    invar_shape_depth_iffs map_cong_preds map_idents pred_congs pred_mono_strongs =
  HEADGOAL (rtac ctxt @{thm pointfree_idI} THEN'
  Subgoal.FOCUS (fn {context = ctxt, params = params, ...} =>
    let
      val t = snd (hd params);
      val T_Rep_t = Thm.apply cT_Rep t;
    in
      unfold_tac ctxt [T_ctr_def, T_dtr_def] THEN
      HEADGOAL (EVERY' [rtac ctxt rev_mp,
        rtac ctxt (infer_instantiate' ctxt [SOME t] (unfold_thms ctxt @{thms mem_Collect_eq} T_Rep)),
        rtac ctxt impI, rtac ctxt (T_Rep_inject RS iffD1),
        rtac ctxt (infer_instantiate' ctxt [SOME T_Rep_t] raw_exhaust)]) THEN
      ALLGOALS
        (let
          val intro = resolve_tac ctxt (allI :: impI :: conjI ::
            map2 (fn cong => fn id => trans OF [cong, id]) map_cong_preds map_idents);
          val elim = eresolve_tac ctxt (conjE :: disjE :: exE ::  pred_mono_strongs);
          val dest = dresolve_tac ctxt (map (fn thm => thm RS iffD1) invar_shape_depth_iffs);
          val simp = asm_full_simp_tac (fold Simplifier.add_cong pred_congs
            (ss_only (flat [T_Abs_inverses,
                map (unfold_thms ctxt @{thms mem_Collect_eq}) T_Reps, T_Rep_inverses,
                invar_raw_simps, raw_cases, raw_injects,
                invar_shape_simps, shape_cases, invar_map_raw_closeds, invar_flat_raws,
                invar_unflat_raws, flat_unflat_raws, pred_maps, pred_Trues, map_comps,
                @{thms snoc.simps(1)[symmetric] o_apply mem_Collect_eq list.case}])
              ctxt));
        in
          REPEAT_DETERM o FIRST' [hyp_subst_tac ctxt, intro, elim, dest, simp]
        end)
    end) ctxt);

  (* map *)

fun mk_map_flat_shape_tac ctxt induct Ps us shape_injects shape_maps flat_simps
    map_comps map_congs =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val simp = full_simp_tac (fold Simplifier.add_cong map_congs
        (ss_only (flat [shape_maps, flat_simps, map_comps, shape_injects, IHs, @{thms o_apply}])
          ctxt));
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, simp])
    end) ctxt);

fun mk_map_flat_raw_tac ctxt induct Ps us raw_maps flat_simps map_comps
    map_flat_shapes map_congs =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val simp = full_simp_tac (fold Simplifier.add_cong map_congs
        (ss_only (flat [raw_maps, flat_simps, map_comps, map_flat_shapes, IHs, @{thms o_apply}])
          ctxt));
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, simp])
    end) ctxt);

fun mk_map_T_eq_tac ctxt T_map_defs T_ctr_def T_Abs_inverses
        raw_maps shape_maps map_flat_raws T_Reps invar_raw_simps
        invar_shape_simps invar_map_raw_closeds invar_flat_raws
        pred_maps pred_Trues map_comps pred_congs map_congs =
  unfold_tac ctxt (T_ctr_def :: T_map_defs) THEN
  HEADGOAL (full_simp_tac (fold Simplifier.add_cong (pred_congs @ map_congs)
        (ss_only (flat [T_Abs_inverses, raw_maps, shape_maps, map_flat_raws,
            map (unfold_thms ctxt @{thms mem_Collect_eq}) T_Reps, invar_raw_simps,
            invar_shape_simps, invar_map_raw_closeds, invar_flat_raws,
            pred_maps, pred_Trues, map_comps,
            @{thms snoc.simps(1)[symmetric] o_apply mem_Collect_eq list.case}])
          ctxt)));

  (* set *)

fun mk_set_flat_shape_tac ctxt induct Ps us shape_sets flat_simps set_maps =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val simp = full_simp_tac (fold Simplifier.add_cong @{thms SUP_cong}
        (ss_only (flat [shape_sets, flat_simps, set_maps, IHs,
        @{thms UN_simps UN_singleton UN_insert UN_empty UN_empty2
          UN_Un UN_Un_distrib Un_ac Un_empty_left}])
          ctxt));
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, simp])
    end) ctxt);

fun mk_set_flat_raw_tac ctxt induct Ps us raw_sets flat_simps set_maps set_flat_shapes =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IHs, ...} =>
    let
      val simp = full_simp_tac (fold Simplifier.add_cong @{thms SUP_cong}
        (ss_only (flat [raw_sets, flat_simps, set_maps, set_flat_shapes, IHs,
        @{thms UN_simps UN_singleton UN_insert UN_empty UN_empty2
          UN_Un UN_Un_distrib Un_ac Un_empty_left}])
          ctxt));
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, simp])
    end) ctxt);


fun mk_set_T_eq_tac ctxt T_set_defs T_ctr_def T_Abs_inverses raw_sets shape_sets
      set_flat_raw T_Reps invar_raw_simps invar_shape_simps invar_flat_raws
      pred_maps pred_Trues set_maps pred_congs =
  unfold_tac ctxt (T_ctr_def :: T_set_defs) THEN
  ALLGOALS (full_simp_tac (fold Simplifier.add_cong pred_congs
        (ss_only (flat [T_Abs_inverses, raw_sets, shape_sets, set_flat_raw,
            map (unfold_thms ctxt @{thms mem_Collect_eq}) T_Reps, invar_raw_simps,
            invar_shape_simps, invar_flat_raws,
            pred_maps, pred_Trues, set_maps,
            @{thms UN_simps UN_singleton UN_empty2 UN_Un UN_Un_distrib Un_ac Un_empty_left
              list.case o_apply mem_Collect_eq snoc.simps(1)[symmetric]}])
          ctxt)));

  (* rel *)

fun mk_rel_final_tac ctxt raw_thm transfer =
  ALLGOALS (EVERY' [
    rtac ctxt (transfer RS @{thm rel_funD} RS @{thm iffI[rotated]}),
    assume_tac ctxt, rtac ctxt raw_thm] THEN_ALL_NEW assume_tac ctxt);

fun mk_rel_flat_shape_raw_tac ctxt induct Ps us invar_shape_simps flat_simps rel_injects
        invar_shape_depth_iffs rel_maps pred_sets rel_mono_strongs label_splits =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct)) THEN
  ALLGOALS (Subgoal.FOCUS (fn {context = ctxt, prems = IH0s, ...} =>
    let
      val IHs = map (fn thm => thm RS spec RS spec RS mp RS mp RS mp) IH0s;
      val apply_IHs = resolve_tac ctxt IHs THEN_ALL_NEW assume_tac ctxt;
      val intro = resolve_tac ctxt [allI, impI, conjI];
      val dest = dtac ctxt bspec THEN' assume_tac ctxt;
      val elim = eresolve_tac ctxt (conjE :: disjE :: exE ::  rel_mono_strongs);
      val simp = full_simp_tac (fold Splitter.add_split (label_splits @ @{thms list.splits if_splits})
        (ss_only (flat [invar_shape_simps, flat_simps, rel_injects, invar_shape_depth_iffs,
        rel_maps, pred_sets, @{thms ball_simps id_apply}])
          ctxt));
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, apply_IHs, intro, elim, dest, simp])
    end) ctxt);

fun mk_rel_flat_raw_raw_tac ctxt induct Ps us raw_exhausts invar_raw_simps flat_simps rel_injects
        rel_maps pred_sets rel_mono_strongs rel_flat_shapes =
  HEADGOAL (rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ us)) induct) THEN_ALL_NEW
   (EVERY' [rtac ctxt allI,
    Subgoal.FOCUS (fn {context = ctxt, params, ...} =>
        let
          val thm = map_filter (try (infer_instantiate' ctxt [SOME (snd (nth params 1))]))
           raw_exhausts;
        in HEADGOAL (resolve_tac ctxt thm) end) ctxt, hyp_subst_tac_thin true ctxt,
    Subgoal.FOCUS (fn {context = ctxt, prems = IH0s, ...} =>
    let
      val IHs = map (fn thm => thm RS spec RS spec RS mp RS mp RS mp) IH0s;
      val apply_IHs = resolve_tac ctxt IHs THEN_ALL_NEW assume_tac ctxt;
      val intro = resolve_tac ctxt [allI, impI, conjI];
      val dest = dtac ctxt bspec THEN' assume_tac ctxt;
      val elim = eresolve_tac ctxt (conjE :: disjE :: exE ::  rel_mono_strongs);
      val simp = asm_full_simp_tac (ss_only (flat [rel_flat_shapes, invar_raw_simps, flat_simps,
        rel_injects, rel_maps, pred_sets, @{thms ball_simps id_apply}])
          ctxt);
    in
      HEADGOAL (REPEAT_DETERM o
       FIRST' [hyp_subst_tac ctxt, apply_IHs, intro, elim, dest, simp])
    end) ctxt]));

fun mk_rel_T_eq_tac ctxt T_rel_defs T_ctr_def T_Abs_inverses
      raw_rel_injects shape_rel_injects rel_flat_rawss T_Reps invar_raw_simps
      invar_shape_simps invar_map_raw_closeds invar_flat_raws
      pred_maps pred_Trues rel_maps pred_congs =
  unfold_tac ctxt (T_ctr_def :: @{thm vimage2p_def} :: T_rel_defs) THEN
  HEADGOAL (full_simp_tac (fold Simplifier.add_cong (pred_congs)
        (ss_only (flat [T_Abs_inverses, raw_rel_injects, shape_rel_injects,
            map2 (fn thms => fn rep =>
              let
                val reps = replicate 2 (unfold_thms ctxt @{thms mem_Collect_eq} rep);
              in
                map (fn thm => thm OF reps) thms
              end) rel_flat_rawss T_Reps |> flat,
            map (unfold_thms ctxt @{thms mem_Collect_eq}) T_Reps,
            invar_raw_simps, invar_shape_simps, invar_map_raw_closeds, invar_flat_raws,
            pred_maps, pred_Trues, rel_maps,
            @{thms snoc.simps(1)[symmetric] o_apply mem_Collect_eq list.case}])
          ctxt)));

  (* co-datatypes *)

fun mk_invar_map_raw_closed_cotac ctxt Ps Qs induct raw_exhausts raw_injects raw_maps
  invar_simps invar_shape_map_closed G_pred_maps G_pred_mono_strongs =
        let
          val n = length Ps;
          fun case_mut a b = if n <> 1 then a else b;
        in
          HEADGOAL (EVERY' [case_mut (rtac ctxt rev_mp) (rtac ctxt iffI),
            rtac ctxt (infer_instantiate' ctxt (map SOME Ps) induct),
            case_mut (K all_tac) (REPEAT_DETERM o (resolve_tac ctxt [exI, conjI, refl]) THEN'
            assume_tac ctxt)]) THEN
          (HEADGOAL o RANGE) (map (fn exhaust =>  (EVERY' [
            Subgoal.FOCUS_PARAMS (fn {context = ctxt, params, ...} =>
              let
                val exhaust_inst = infer_instantiate' ctxt [(SOME o snd) (nth params 1)] exhaust;
                val intro = resolve_tac ctxt [exI, conjI, disjI1];
                val elim = eresolve_tac ctxt (exE :: conjE :: G_pred_mono_strongs);
                val simp = asm_full_simp_tac (ss_only (flat [raw_injects, raw_maps, invar_simps,
                  invar_shape_map_closed, G_pred_maps, @{thms simp_thms ex_simps o_apply}]) ctxt);
              in
                HEADGOAL (EVERY' [rtac ctxt exhaust_inst, REPEAT_DETERM o
                  FIRST' [hyp_subst_tac ctxt, elim, intro, simp]])
              end) ctxt])) raw_exhausts) THEN
          HEADGOAL (EVERY' [case_mut (rtac ctxt rev_mp) (K all_tac),
            rtac ctxt (infer_instantiate' ctxt (map SOME Qs) induct),
            case_mut (K all_tac) (REPEAT_DETERM o (resolve_tac ctxt [exI, conjI, refl]) THEN'
            assume_tac ctxt)]) THEN
          (HEADGOAL o RANGE) (map (fn exhaust =>  (EVERY' [
            REPEAT_DETERM o (eresolve_tac ctxt [exE, conjE]),
            Subgoal.FOCUS_PARAMS (fn {context = ctxt, params, ...} =>
              let
                val exhaust_inst = infer_instantiate' ctxt [(SOME o snd) (nth params 3)] exhaust;
                val intro = resolve_tac ctxt (conjI :: exI :: disjI1 :: []);
                val elim = eresolve_tac ctxt G_pred_mono_strongs;
                val simp = asm_full_simp_tac (ss_only (flat [raw_maps, invar_simps,
                  invar_shape_map_closed, G_pred_maps, @{thms o_apply}]) ctxt);
              in
                HEADGOAL (EVERY' [rtac ctxt exhaust_inst, REPEAT_DETERM o
                  FIRST' [hyp_subst_tac ctxt, intro, elim, simp]])
              end) ctxt])) raw_exhausts) THEN
          case_mut ( unfold_tac ctxt @{thms ex_simps simp_thms(39,40)} THEN
          HEADGOAL (EVERY' [rtac ctxt impI, rtac ctxt impI,
            CONJ_WRAP' (fn i => EVERY' [
              dtac ctxt (mk_conjunctN n i),
              dtac ctxt (mk_conjunctN n i),
              rtac ctxt iffI,

              etac ctxt thin_rl,
              REPEAT_DETERM o (eresolve_tac ctxt [allE, mp]),
              REPEAT_DETERM o (resolve_tac ctxt [exI, conjI, refl]),
              assume_tac ctxt,

              dtac ctxt asm_rl,
              etac ctxt thin_rl,
              REPEAT_DETERM o (eresolve_tac ctxt [allE, mp]),
              REPEAT_DETERM o (resolve_tac ctxt [exI, conjI, refl]),
              assume_tac ctxt
            ]) (1 upto n)])) (all_tac)
        end

fun mk_invar_raw_flat_raw_cotac ctxt Ps induct raw_exhausts raw_injects raw_maps
  raw_sels invar_simps flat_simps invar_shape_flat_shape
  G_pred_maps G_rel_mono_strongs =
  let
    val n = length Ps;
    fun case_mut a b = if n <> 1 then a else b;
  in
    HEADGOAL (EVERY' [case_mut (rtac ctxt rev_mp) (rtac ctxt impI),
      rtac ctxt (infer_instantiate' ctxt (map SOME Ps) induct),
      case_mut (K all_tac) (REPEAT_DETERM o (resolve_tac ctxt [exI, conjI, refl]) THEN'
      assume_tac ctxt)]) THEN
    (HEADGOAL o RANGE) (map (fn exhaust =>  (EVERY' [
      REPEAT_DETERM o (eresolve_tac ctxt [exE, conjE]),
      hyp_subst_tac ctxt,
      Subgoal.FOCUS_PARAMS (fn {context = ctxt, params, ...} =>
        let
          val exhaust_inst = infer_instantiate' ctxt [(SOME o snd) (nth params 3)] exhaust;
          val intro = resolve_tac ctxt (conjI :: exI :: disjI1 :: []);
          val elim = eresolve_tac ctxt G_rel_mono_strongs;
          val simp = asm_full_simp_tac (ss_only (flat [raw_injects, raw_maps, raw_sels, invar_simps,
            flat_simps, invar_shape_flat_shape, G_pred_maps, @{thms snoc.simps[symmetric] o_apply}]) ctxt);
        in
          HEADGOAL (EVERY' [rtac ctxt exhaust_inst, REPEAT_DETERM o
            FIRST' [hyp_subst_tac ctxt, intro, elim, simp]])
        end) ctxt])) raw_exhausts) THEN
    HEADGOAL (case_mut (EVERY' [rtac ctxt impI,
      CONJ_WRAP' (fn i => EVERY' [
        dtac ctxt (mk_conjunctN n i), rtac ctxt impI,
        REPEAT_DETERM o (eresolve_tac ctxt [allE, mp]),
        REPEAT_DETERM o (resolve_tac ctxt [exI, conjI, refl]),
        assume_tac ctxt
      ]) (1 upto n)]) (K all_tac))
  end

fun mk_invar_raw_unflat_raw_cotac ctxt Ps induct raw_exhausts raw_injects raw_maps
  raw_sels invar_simps unflat_simps invar_shape_unflat_shape
  G_pred_maps G_rel_mono_strongs =
  let
    val n = length Ps;
    fun case_mut a b = if n <> 1 then a else b;
  in
    HEADGOAL (EVERY' [case_mut (rtac ctxt rev_mp) (rtac ctxt impI),
      rtac ctxt (infer_instantiate' ctxt (map SOME Ps) induct),
      case_mut (K all_tac) (REPEAT_DETERM o (resolve_tac ctxt [exI, conjI, refl]) THEN'
      assume_tac ctxt)]) THEN
    (HEADGOAL o RANGE) (map (fn exhaust =>  (EVERY' [
      REPEAT_DETERM o (eresolve_tac ctxt [exE, conjE]),
      hyp_subst_tac ctxt,
      Subgoal.FOCUS_PARAMS (fn {context = ctxt, params, ...} =>
        let
          val exhaust_inst = infer_instantiate' ctxt [(SOME o snd) (nth params 3)] exhaust;
          val intro = resolve_tac ctxt (conjI :: exI :: disjI1 :: []);
          val elim = eresolve_tac ctxt G_rel_mono_strongs;
          val simp = asm_full_simp_tac (ss_only (flat [raw_injects, raw_maps, raw_sels, invar_simps,
            unflat_simps, invar_shape_unflat_shape, G_pred_maps, @{thms snoc.simps[symmetric] o_apply}]) ctxt);
        in
          HEADGOAL (EVERY' [rtac ctxt exhaust_inst, REPEAT_DETERM o
            FIRST' [hyp_subst_tac ctxt, intro, elim, simp]])
        end) ctxt])) raw_exhausts) THEN
    HEADGOAL (case_mut (EVERY' [rtac ctxt impI,
      CONJ_WRAP' (fn i => EVERY' [
        dtac ctxt (mk_conjunctN n i), rtac ctxt impI,
        REPEAT_DETERM o (eresolve_tac ctxt [allE, mp]),
        REPEAT_DETERM o (resolve_tac ctxt [exI, conjI, refl]),
        assume_tac ctxt
      ]) (1 upto n)]) (K all_tac))
  end

fun mk_flat_raw_unflat_raw_cotac ctxt Ps xs ys induct raw_exhausts raw_sels
  flat_simps unflat_simps invar_simps flat_shape_unflat_shapes
  G_rel_maps G_pred_rels G_rel_mono_strongs =
  let
    val n = length Ps;
    fun case_mut a b = if n <> 1 then a else b;
  in
    HEADGOAL (EVERY' [case_mut (rtac ctxt rev_mp) (rtac ctxt impI),
      rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ ([xs, ys] |> transpose |> flat))) induct),
      case_mut (K all_tac) (REPEAT_DETERM o (resolve_tac ctxt [exI, conjI, refl]) THEN'
      assume_tac ctxt)]) THEN
    HEADGOAL (RANGE (map (fn exhaust =>  (EVERY' [
      REPEAT_DETERM o (eresolve_tac ctxt [exE, conjE]),
      hyp_subst_tac ctxt,
      Subgoal.FOCUS_PARAMS (fn {context = ctxt, params, ...} =>
        let
          val exhaust_inst = infer_instantiate' ctxt [(SOME o snd) (nth params 3)] exhaust;
          val intro = resolve_tac ctxt (allI :: impI :: conjI :: exI :: []);
          val elim = eresolve_tac ctxt (conjE :: disjE :: exE :: not_sym :: (not_sym RS disjI1) :: G_rel_mono_strongs);
          val simp = asm_full_simp_tac (ss_only (flat [raw_sels, flat_simps, unflat_simps, invar_simps,
            flat_shape_unflat_shapes, G_rel_maps, G_pred_rels, @{thms snoc.simps[symmetric] eq_onp_def
            simp_thms snoc_neq_Nil}]) ctxt);
        in
          HEADGOAL (EVERY' [rtac ctxt exhaust_inst, REPEAT_DETERM o
            FIRST' [hyp_subst_tac ctxt, intro, elim, simp]])
        end) ctxt])) raw_exhausts)) THEN
    HEADGOAL (case_mut (EVERY' [rtac ctxt impI,
      CONJ_WRAP' (fn i => EVERY' [
        dtac ctxt (mk_conjunctN n i), rtac ctxt impI,
        REPEAT_DETERM o (eresolve_tac ctxt [allE, mp]),
        REPEAT_DETERM o (resolve_tac ctxt [exI, conjI, refl]),
        assume_tac ctxt
      ]) (1 upto n)]) (K all_tac))
  end

fun mk_unflat_raw_flat_raw_cotac ctxt Ps xs ys induct raw_exhausts raw_sels
  flat_simps unflat_simps invar_simps flat_shape_unflat_shapes
  G_rel_maps G_pred_rels G_rel_mono_strongs =
  let
    val n = length Ps;
    fun case_mut a b = if n <> 1 then a else b;
  in
    HEADGOAL (EVERY' [case_mut (rtac ctxt rev_mp) (rtac ctxt impI),
      rtac ctxt (infer_instantiate' ctxt (map SOME (Ps @ ([xs, ys] |> transpose |> flat))) induct),
      case_mut (K all_tac) (REPEAT_DETERM o (resolve_tac ctxt [exI, conjI, refl]) THEN'
      assume_tac ctxt)]) THEN
    (HEADGOAL o RANGE) (map (fn exhaust =>  (EVERY' [
      REPEAT_DETERM o (eresolve_tac ctxt [exE, conjE]),
      hyp_subst_tac ctxt,
      Subgoal.FOCUS_PARAMS (fn {context = ctxt, params, ...} =>
        let
          val exhaust_inst = infer_instantiate' ctxt [(SOME o snd) (nth params 3)] exhaust;
          val intro = resolve_tac ctxt (exI :: []);
          val elim = eresolve_tac ctxt (conjE :: G_rel_mono_strongs);
          val simp = asm_full_simp_tac (ss_only (flat [raw_sels, flat_simps, unflat_simps, invar_simps,
            flat_shape_unflat_shapes, G_rel_maps, G_pred_rels, @{thms eq_onp_def}]) ctxt);
        in
          HEADGOAL (EVERY' [rtac ctxt exhaust_inst, REPEAT_DETERM o
            FIRST' [hyp_subst_tac ctxt, intro, elim, simp]])
        end) ctxt])) raw_exhausts) THEN
    HEADGOAL (case_mut (EVERY' [rtac ctxt impI,
      CONJ_WRAP' (fn i => EVERY' [
        dtac ctxt (mk_conjunctN n i), rtac ctxt impI,
        REPEAT_DETERM o (eresolve_tac ctxt [allE, mp]),
        REPEAT_DETERM o (resolve_tac ctxt [exI, conjI, refl]),
        assume_tac ctxt
      ]) (1 upto n)]) (K all_tac))
  end

fun mk_map_flat_raw_cotac ctxt Ps xs ys induct raw_exhausts raw_sels
  raw_maps flat_simps map_flat_shapes
  G_rel_maps G_rel_refl =
  let
    val n = length Ps;
    fun case_mut a b = if n <> 1 then a else b;
    val inst_cterms = Ps @ ([xs, ys] |> transpose |> flat);
  in
    HEADGOAL (EVERY' [case_mut (rtac ctxt rev_mp) (K all_tac),
      rtac ctxt (infer_instantiate' ctxt (map SOME inst_cterms) induct),
      case_mut (K all_tac) (REPEAT_DETERM o (resolve_tac ctxt [exI, conjI, refl]))]) THEN
    (HEADGOAL o RANGE) (map (fn exhaust =>  (EVERY' [
      REPEAT_DETERM o (eresolve_tac ctxt [exE, conjE]),
      hyp_subst_tac ctxt,
      Subgoal.FOCUS (fn {context = ctxt, params, ...} =>
        let
          val exhaust_inst = infer_instantiate' ctxt [(SOME o snd) (nth params 3)] exhaust;
          val intro = resolve_tac ctxt (exI :: G_rel_refl);
          val simp = asm_full_simp_tac (ss_only (flat [raw_sels, raw_maps, flat_simps,
            map_flat_shapes, G_rel_maps, @{thms snoc.simps[symmetric] eq_onp_def}]) ctxt);
        in
          HEADGOAL (EVERY' [rtac ctxt exhaust_inst, REPEAT_DETERM o
            FIRST' [hyp_subst_tac ctxt, intro, simp]])
        end) ctxt])) raw_exhausts) THEN
    HEADGOAL (case_mut (
      rtac ctxt impI THEN'
      CONJ_WRAP' (fn i => EVERY' [
        dtac ctxt (mk_conjunctN n i),
        etac ctxt mp,
        SELECT_GOAL (REPEAT_DETERM (HEADGOAL (FIRST' [
          resolve_tac ctxt [exI, conjI, refl],
          assume_tac ctxt])))]) (1 upto n)) (K all_tac))
  end


fun mk_set_flat_raw_cotac ctxt lemma Pss us induct inducts nr_occ raw_exhausts raw_injects raw_sets
  flat_simps set_flat_shapes G_set_maps =
  let
    val nr_par = length Pss;
    val nr_Ts = length (hd Pss);
    val nr_lives = nr_par + nr_occ;
    fun case_mut a b = if nr_Ts <> 1 then a else b;
    val rep_raw_exhausts = map (replicate nr_lives) raw_exhausts |> flat;
    val UnI_pars = map (mk_UnIN nr_par) (1 upto nr_par);
    val UnI_Gs = map (mk_UnIN nr_lives) (1 upto nr_lives);
    val solve = EVERY' [rtac ctxt equalityI, rtac ctxt subsetI,
      etac ctxt allE, dtac ctxt bspec, assume_tac ctxt,
      etac ctxt allE, dtac ctxt mp, rtac ctxt refl, assume_tac ctxt];
  in
    HEADGOAL (EVERY' [rtac ctxt (infer_instantiate' ctxt [SOME lemma] rev_mp),
      REPEAT_DETERM_N nr_Ts o rtac ctxt allI,
      case_mut (rtac ctxt induct)
      (rtac ctxt ballI THEN' etac ctxt induct) THEN_ALL_NEW
      REPEAT_DETERM o resolve_tac ctxt [allI, impI],
      RANGE (map (fn exhaust =>
      Subgoal.FOCUS_PARAMS (fn {context = ctxt, params, ...} =>
        let
          val exhaust_inst = infer_instantiate' ctxt [(SOME o snd o List.last) params] exhaust;
        in
          HEADGOAL (rtac ctxt exhaust_inst)
        end) ctxt THEN' REPEAT_DETERM o
        let
          val elim = eresolve_tac ctxt (imageE :: UnE :: @{thms UN_E});
          val dest_IH = etac ctxt allE THEN' dtac ctxt mp THEN' rtac ctxt refl;
          val solve = EVERY' [resolve_tac ctxt UnI_pars, etac ctxt @{thm UN_I[rotated]},
            resolve_tac ctxt UnI_Gs, etac ctxt @{thm UN_I[rotated]}, assume_tac ctxt];
          val simp = CHANGED o asm_full_simp_tac
            (ss_only (flat [raw_sets, raw_injects, flat_simps, set_flat_shapes,
              G_set_maps]) ctxt);
        in
          FIRST' [hyp_subst_tac ctxt, elim, solve, dest_IH, simp]
        end) rep_raw_exhausts)]) THEN
    HEADGOAL (case_mut (K all_tac) (EVERY' [
      rtac ctxt impI,
      solve,
      rtac ctxt subsetI,
      REPEAT_ALL_NEW (eresolve_tac ctxt @{thms UnE UN_E})])) THEN
    HEADGOAL (EVERY' (map2 (fn induct => fn Ps =>
      EVERY' [rtac ctxt rev_mp,
        let
          val instantiate_args = case_mut (map SOME (Ps @ us)) (NONE :: map SOME (us @ Ps));
          val dest_IH = dtac ctxt bspec THEN' assume_tac ctxt;
          val solve = EVERY' [resolve_tac ctxt UnI_Gs, etac ctxt @{thm UN_I}] THEN'
            TRY o EVERY' [resolve_tac ctxt UnI_pars,
            etac ctxt @{thm UN_I[rotated]}, assume_tac ctxt];
          val intro = resolve_tac ctxt (impI :: ballI :: []);
          val simp = CHANGED o asm_full_simp_tac (ss_only (flat [raw_sets, flat_simps,
            set_flat_shapes, G_set_maps, @{thms UN_simps}]) ctxt);
        in
          rtac ctxt (infer_instantiate' ctxt instantiate_args induct) THEN_ALL_NEW
          REPEAT_DETERM o FIRST' [intro, solve, dest_IH, simp]
        end]) inducts Pss)) THEN
    case_mut (unfold_tac ctxt @{thms all_simps} THEN
    HEADGOAL (EVERY' [REPEAT_DETERM o rtac ctxt impI,
      CONJ_WRAP' (fn i => EVERY' [
        dtac ctxt (mk_conjunctN nr_Ts i),
        EVERY' (replicate nr_par (dtac ctxt (mk_conjunctN nr_Ts i))),
        solve,
        rtac ctxt subsetI,
        REPEAT_DETERM o etac ctxt UnE,
        EVERY' (replicate nr_par (EVERY' [
          etac ctxt @{thm UN_E},
          REPEAT_DETERM o (dtac ctxt bspec THEN' assume_tac ctxt),
          assume_tac ctxt]))
      ]) (1 upto nr_Ts)])) (HEADGOAL (REPEAT_DETERM_N nr_Ts o EVERY' [
        rtac ctxt impI,
        REPEAT_DETERM o (dtac ctxt bspec THEN' assume_tac ctxt),
        assume_tac ctxt]))
  end

fun mk_rel_flat_raw_raw_cotac ctxt Ps Rs xs ys induct raw_exhausts raw_sels raw_rel_injects
  flat_simps invar_raw_simps rel_flat_shapes
  G_rel_maps G_pred_sets G_rel_refl G_rel_congs G_rel_mono_strongs =
  let
    val n = length Ps;
    fun case_mut a b = if n <> 1 then a else b;
    val infer_args = case_mut ((hd Ps :: Rs @ tl Ps) @ ([xs, ys] |> transpose |> flat))
      (hd Ps :: ([xs, ys] |> transpose |> flat) @ Rs);
  in
    HEADGOAL (EVERY' [case_mut (rtac ctxt rev_mp) (REPEAT_DETERM o (rtac ctxt impI)),
      rtac ctxt (infer_instantiate' ctxt (map SOME infer_args) induct),
      case_mut (K all_tac) (REPEAT_DETERM o FIRST' [resolve_tac ctxt [exI, conjI], assume_tac ctxt])]) THEN
    (HEADGOAL o RANGE) (map (fn exhaust => EVERY' [
      REPEAT_DETERM o (eresolve_tac ctxt [exE, conjE]),
      Subgoal.FOCUS_PARAMS (fn {context = ctxt, params, ...} =>
        let
          val exhaust_tacs = map (fn param =>
            rtac ctxt (infer_instantiate' ctxt ((single o SOME o snd) param) exhaust)) (take 2 params);
          val intro = resolve_tac ctxt (exI :: G_rel_refl);
          val elim = eresolve_tac ctxt (exE :: conjE :: G_rel_mono_strongs);
          val dest_bspec = dtac ctxt bspec THEN' assume_tac ctxt;
          val rel_flat_shapesI = map (fn thm => thm RS iffD1) rel_flat_shapes;
          val apply_rel_flat = resolve_tac ctxt rel_flat_shapesI THEN_ALL_NEW assume_tac ctxt;
          val simp = asm_full_simp_tac (fold Simplifier.add_cong G_rel_congs
            (ss_only (flat [raw_sels, raw_rel_injects, flat_simps,
              invar_raw_simps, G_rel_maps, G_pred_sets]) ctxt));
        in
          HEADGOAL (EVERY' exhaust_tacs THEN' REPEAT_DETERM o
            FIRST' [hyp_subst_tac ctxt, intro, elim, dest_bspec, apply_rel_flat, simp])
        end) ctxt]) raw_exhausts) THEN
    HEADGOAL (case_mut (
      rtac ctxt impI THEN'
      CONJ_WRAP' (fn i => EVERY' [
        dtac ctxt (mk_conjunctN n i),
        REPEAT_DETERM o resolve_tac ctxt [allI, impI],
        etac ctxt mp,
        SELECT_GOAL (REPEAT_DETERM (HEADGOAL (FIRST' [
          resolve_tac ctxt [exI, conjI],
          assume_tac ctxt])))]) (1 upto n)) (K all_tac))
  end;


(* bnf_fp_rec *)

fun mk_defobj_natural_tac ctxt =
  Skip_Proof.cheat_tac ctxt 1;
fun mk_argobj_natural_tac ctxt =
  Skip_Proof.cheat_tac ctxt 1;
fun mk_defobj_invar_tac ctxt =
  Skip_Proof.cheat_tac ctxt 1;
fun mk_argobj_invar_tac ctxt =
  Skip_Proof.cheat_tac ctxt 1;

(* lemmas about f *)

fun mk_f_shape_flat_shape_tac ctxt =
  Skip_Proof.cheat_tac ctxt 1;
fun mk_invar_shape_f_shape_tac ctxt =
  Skip_Proof.cheat_tac ctxt 1;
fun mk_f_raw_flat_raw_tac ctxt =
  Skip_Proof.cheat_tac ctxt 1;
fun mk_invar_raw_f_raw_tac ctxt =
  Skip_Proof.cheat_tac ctxt 1;
fun mk_f_T_Appl_tac ctxt =
  Skip_Proof.cheat_tac ctxt 1;

(* bnf_fp_ind *)

fun mk_P_mono_tac ctxt nr_param P_param us T_rel_Grp =
  HEADGOAL (Method.insert_tac ctxt [infer_instantiate' ctxt (map SOME us) P_param]) THEN
  unfold_tac ctxt (T_rel_Grp :: @{thms rel_fun_def left_total_Grp bi_unique_Grp}) THEN
  unfold_tac ctxt @{thms Grp_def} THEN
  HEADGOAL (EVERY' [
    asm_full_simp_tac (ss_only @{thms mem_Collect_eq True_implies_equals subset_UNIV simp_thms(21)
      all_simps(6)[symmetric]} ctxt),
    REPEAT_DETERM_N nr_param o etac ctxt thin_rl,
    REPEAT_DETERM o dtac ctxt spec,
    REPEAT_DETERM o (dtac ctxt mp THEN' rtac ctxt refl), assume_tac ctxt]);

fun put_snd_NONE fp_kind xs = xs (*hd xs :: case_fp fp_kind [NONE] [NONE, NONE] @ tl xs*)

fun mk_PP_unCons_co_tac fp_kind ctxt unCons_cimmerse P_co_ind P_inj_monos rel_mono_strong Nodess
    raw_splits raw_inject set_maps rel_maps pred_set shape_injects shape_cases
    invar_shape_depth_iffs invar_unflat invar_simps invar_cimmerse
    un_T_defs Abs_T_inverses map_T_defs =
  let
    val arity = case_fp fp_kind 1 2;
    val xtac = case_fp fp_kind rtac dtac;
    val predD = case_fp fp_kind @{thm predicate1D}
      @{thm vimage2pD[OF predicate2D[of _ "BNF_Def.vimage2p f g R" for f g R]]}
  in
    unfold_thms_tac ctxt ((unCons_cimmerse RS sym) :: @{thms rev.simps(1)}) THEN
    HEADGOAL (xtac ctxt (P_co_ind RS predD) THEN'
      EVERY' (replicate arity (dtac ctxt invar_cimmerse)) THEN'
      let
        val inj_mono = FIRST' (maps (fn P_inj_mono => map (fn Nodes =>
            (infer_instantiate' ctxt (map SOME Nodes |> put_snd_NONE fp_kind) P_inj_mono RS mp)
            |> Drule.rotate_prems ~1
            |> xtac ctxt) (Nodess |> transpose)) P_inj_monos);
        val intro = resolve_tac ctxt [allI, impI, conjI, ballI];
        val bspec = dtac ctxt bspec THEN' assume_tac ctxt;
        val elim = eresolve_tac ctxt (case_fp fp_kind I (cons rel_mono_strong) [conjE, exE]);
        val simp = CHANGED o asm_full_simp_tac (fold Splitter.add_split raw_splits (ss_only (flat
          [un_T_defs, Abs_T_inverses, map_T_defs, case_fp fp_kind set_maps rel_maps,
            [pred_set, raw_inject, invar_cimmerse],
            invar_shape_depth_iffs, shape_injects, shape_cases, invar_unflat, invar_simps,
            @{thms mem_Collect_eq o_apply id_apply snoc.simps inj_on_def
              simp_thms ball_simps ball_triv}])
          ctxt));
      in
        REPEAT_DETERM o FIRST' [hyp_subst_tac ctxt, inj_mono, bspec, elim, intro, simp]
      end)
  end;

fun mk_PP_co_tac fp_kind ctxt co_induct PPs rs unCons_defs P_unConss rel_mono_strongs
    cimmerse_shape_injs raw_splits set_maps rel_maps invar_simps pred_sets raw_injects =
  let
    val co_induct = infer_instantiate' ctxt (map SOME (PPs @ rs)) co_induct
      |> unfold_thms ctxt unCons_defs;
    val arity = case_fp fp_kind 1 2;
    val co_only = case_fp fp_kind (K no_tac);
    val init_tac = case_fp fp_kind (rtac ctxt co_induct) (if length PPs = 1 then
      rtac ctxt impI THEN' etac ctxt co_induct else rtac ctxt co_induct);
    val xresolve_tac = case_fp fp_kind resolve_tac dresolve_tac;
    val prepare_tac =
      case_fp fp_kind
        (rtac ctxt allI THEN' rtac ctxt impI)
        (REPEAT_DETERM o eresolve_tac ctxt [exE, conjE]) THEN'
      xresolve_tac ctxt (map (case_fp fp_kind I (Drule.rotate_prems ~1)) P_unConss) THEN'
      EVERY' (replicate arity (assume_tac ctxt));
    val intro = resolve_tac ctxt (case_fp fp_kind [allI, impI, conjI] [allI, impI]);
    val elim = case_fp fp_kind (etac ctxt imageE)
      (eresolve_tac ctxt (conjE :: rel_mono_strongs @
        map (Drule.rotate_prems ~1) cimmerse_shape_injs));
    val bspec = co_only (dtac ctxt bspec THEN' assume_tac ctxt);
    val simp = CHANGED o asm_full_simp_tac (Simplifier.add_cong @{thm strong_ball_cong}
      (fold Splitter.add_split raw_splits (ss_only (flat
      [case_fp fp_kind set_maps rel_maps, invar_simps, pred_sets, raw_injects,
      case_fp fp_kind
        @{thms id_apply rev_snoc Ball_def simp_thms implies_True_equals}
        @{thms id_apply rev_snoc}]) ctxt)));
    val exI = co_only (rtac ctxt exI THEN'
      REPEAT_DETERM o rtac ctxt (Drule.rotate_prems ~1 conjI) THEN' assume_tac ctxt);
  in
    HEADGOAL (init_tac THEN_ALL_NEW
      (SELECT_GOAL (HEADGOAL (prepare_tac THEN' REPEAT_DETERM o
        FIRST' [hyp_subst_tac ctxt, elim, intro, bspec, simp, exI]))))
  end;

fun mk_P_tac ctxt PP depth_Nil Rep Leaves mapT t Abs_T_cases Rep_T_inverse Rep_T P_inj_mono
    shape_injects cimmerse_simps =
  let
    val PP = infer_instantiate' ctxt (map SOME [depth_Nil,
      Thm.apply Rep (Thm.apply (Drule.list_comb (mapT, Leaves)) t)]) (PP RS spec RS mp);
    val Abs_cases = infer_instantiate' ctxt [SOME t] Abs_T_cases;
    val inj_mono =
      (infer_instantiate' ctxt (map SOME Leaves |> put_snd_NONE Least_FP) P_inj_mono RS mp)
      |> Drule.rotate_prems ~1;
    val Rep_T = unfold_thms ctxt @{thms mem_Collect_eq} Rep_T;
  in
    HEADGOAL (Method.insert_tac ctxt [PP] THEN' rtac ctxt Abs_cases THEN'
      REPEAT_DETERM o FIRST' [dtac ctxt inj_mono,
        asm_full_simp_tac (ss_only (flat [shape_injects, cimmerse_simps,
        [Rep_T_inverse, Rep_T],
        @{thms rev.simps simp_thms ball_simps inj_on_def True_implies_equals ball_triv}]) ctxt)])
  end;

fun mk_P_cotac ctxt Leaves Abs_T_inject Abs_T_cases Abs_T_inverse PP invar_map_closed
     raw_inj_map_strong P_inj_mono map_T_def shape_injects cimmerse_simps =
  let
    val inj_mono = infer_instantiate' ctxt (map SOME Leaves |> put_snd_NONE Greatest_FP) P_inj_mono;
  in
    HEADGOAL (rtac ctxt @{thm predicate2I} THEN'
      Subgoal.FOCUS_PARAMS (fn {context = ctxt, params, ...} =>
        let
          val Abs_cases = map (fn p => infer_instantiate' ctxt [SOME (snd p)] Abs_T_cases) params;
        in
          HEADGOAL (EVERY' [EVERY' (map (rtac ctxt) Abs_cases), hyp_subst_tac ctxt,
            rtac ctxt (Abs_T_inject RS iffD2), assume_tac ctxt, assume_tac ctxt,
            rtac ctxt (infer_instantiate' ctxt
              (NONE :: NONE :: maps (replicate 2 o SOME) Leaves) raw_inj_map_strong) THEN_ALL_NEW
              asm_full_simp_tac (ss_only shape_injects ctxt),
            rtac ctxt (PP RS mp),
            dtac ctxt (Drule.rotate_prems ~1 (inj_mono RS mp)) THEN_ALL_NEW
              asm_full_simp_tac (ss_only (flat [shape_injects,
                @{thms inj_on_def simp_thms ball_simps ball_triv}]) ctxt),
            rtac ctxt @{thm exI[of _ "[]"]},
            asm_full_simp_tac (ss_only (flat [invar_map_closed, cimmerse_simps,
              [map_T_def, Abs_T_inverse], @{thms o_apply mem_Collect_eq rev.simps(1)}]) ctxt)])
        end)
      ctxt)
  end;

end;
